/*
 * $Id: string.h 743138 2015-10-30 22:45:28Z ib-builder $
 *
 * fcntl.h -- shim header for g++ support
 *
 * Stu Grossman, March 2007
 *
 * Copyright (c) 2007-2008, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * C++ expects memmove to be a real function, not a macro.  Also, the strerror
 * prototype should be in string.h, not stdio.h (as in the ukern).  We'll fix
 * that later.  Also, index is deprecated.
 */

#ifndef __LIBSTDCXX_EMBEDDED_STRING_H__
#define __LIBSTDCXX_EMBEDDED_STRING_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
#include <defs.h>
typedef SIGNED_32 ssize_t;
#endif

#include "../../../../include/string.h"

#undef memmove

void *memmove(void *, const void *, size_t);
int strcoll(const char *, const char *);
unsigned long strxfrm(char *, const char *, size_t);
char *strerror(int);

#undef index

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_EMBEDDED_STRING_H__ */
