/* Target definitions for GCC for Intel 80386 for Juniper
   Copyright (C) 1988, 1991, 1995, 2000, 2001, 2002, 2004
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#undef TARGET_VERSION
#if TARGET_64BIT
#define TARGET_VERSION fprintf (stderr, " (x86_64 Juniper ELF target)");
#else
#define TARGET_VERSION fprintf (stderr, " (i386 Juniper ELF target)");
#endif

#undef CC1_SPEC
#define CC1_SPEC ""

#undef LIB_SPEC
#define LIB_SPEC "\
  %{!shared:								\
    %{!pg: %{pthread:-lpthread} -lc}					\
    %{pg:  %{pthread:-lpthread_p} -lc_p}}				\
  %{shared:								\
    %{pthread:-lpthread}}						\
  "

#undef ENDFILE_SPEC
#define ENDFILE_SPEC FBSD_ENDFILE_SPEC

#undef STARTFILE_SPEC
#define STARTFILE_SPEC FBSD_STARTFILE_SPEC

#undef  SUBTARGET_EXTRA_SPECS   /* previously defined in freebsd.h  */
#define SUBTARGET_EXTRA_SPECS \
  { "junos_dynamic_linker", \
    "%{!m32:/libexec/ld-elf64.so.1} %{m32:/usr/libexec/ld-elf.so.1}" }

#undef  LINK_SPEC
#define LINK_SPEC "\
  %{!m32:-m elf_x86_64_fbsd} %{m32:-m elf_i386_fbsd} \
  %{v:-V} \
  %{assert*} %{R*} %{rpath*} %{defsym*} \
  %{shared:-Bshareable %{h*} %{soname*}} \
    %{!shared: \
      %{!static: \
        %{rdynamic:-export-dynamic} \
        %{!dynamic-linker:-dynamic-linker %(junos_dynamic_linker) }} \
    %{static:-Bstatic}} \
  %{symbolic:-Bsymbolic}"

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()          \
  do                                            \
    {                                           \
      if (TARGET_64BIT)                         \
        {                                       \
          builtin_define ("__LP64__");          \
        }                                       \
    }                                           \
  while (0)

/* asm uses # for comments (FreeBSD style). */

#undef ASM_COMMENT_START
#define ASM_COMMENT_START "#"

#undef ASM_APP_ON
#define ASM_APP_ON "#APP\n"

#undef ASM_APP_OFF
#define ASM_APP_OFF "#NO_APP\n"

/* Tell final.c that we don't need a label passed to mcount.  */

#undef MCOUNT_NAME
#define MCOUNT_NAME ".mcount"

/* Make gcc agree with <machine/ansi.h>.  */

#undef  SIZE_TYPE
#define SIZE_TYPE       (TARGET_64BIT ? "long unsigned int" : "unsigned int")

#undef  PTRDIFF_TYPE
#define PTRDIFF_TYPE    (TARGET_64BIT ? "long int" : "int")

