/* Target definitions for GCC for MIPS for Juniper
   Copyright (C) 2007
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#undef TARGET_VERSION
#define TARGET_VERSION fprintf (stderr, " (MIPS Juniper ELF)");

/* This defines which switch letters take arguments.  -G is a MIPS
   special.  */

#undef  SWITCH_TAKES_ARG
#define SWITCH_TAKES_ARG(CHAR)		\
  (FBSD_SWITCH_TAKES_ARG (CHAR)		\
   || (CHAR) == 'R'			\
   || (CHAR) == 'G')

/* config/mips/mips.h defines CC1_SPEC,
   but gives us an "out" with SUBTARGET_CC1_SPEC.  */
#undef  SUBTARGET_CC1_SPEC
#define SUBTARGET_CC1_SPEC "%{profile:-p}"

#define	STARTFILE_FREEBSD_SPEC	FBSD_STARTFILE_SPEC
#define ENDFILE_FREEBSD_SPEC	FBSD_ENDFILE_SPEC
#define LIB_FREEBSD_SPEC	FBSD_LIB_SPEC
#define CPP_OS_FREEBSD_SPEC	FBSD_CPP_SPEC

#define LINK_START_FREEBSD_SPEC	""

/* Define any extra SPECS that the compiler needs to generate.  */
#undef  SUBTARGET_EXTRA_SPECS
#define SUBTARGET_EXTRA_SPECS						\
  { "lib_freebsd",		LIB_FREEBSD_SPEC },			\
  { "startfile_freebsd",	STARTFILE_FREEBSD_SPEC },		\
  { "endfile_freebsd",		ENDFILE_FREEBSD_SPEC },			\
  { "link_start_freebsd",	LINK_START_FREEBSD_SPEC },		\
  { "link_os",			LINK_OS_SPEC },				\
  { "link_os_freebsd",		LINK_OS_FREEBSD_SPEC },			\
  { "link_os_default",		LINK_OS_DEFAULT_SPEC },			\
  { "cpp_os_freebsd",		CPP_OS_FREEBSD_SPEC },			\
  { "asm_os",			ASM_OS_SPEC },				\
  { "asm_os_freebsd",		ASM_OS_FREEBSD_SPEC },			\
  { "asm_os_default",		ASM_OS_DEFAULT_SPEC },			\
  SUBSUBTARGET_EXTRA_SPECS

#define SUBSUBTARGET_EXTRA_SPECS

#define DRIVER_SELF_SPECS \
    "%{!EB:%{!EL:%(endian_spec)}}", \
"%{!mabi=*: -mabi=32}"

#define ASM_OS_FREEBSD_SPEC \
    "%{!mno-abicalls: %{!fno-PIC:%{!fno-pic:-KPIC}}}"

#undef ENDFILE_SPEC
#define ENDFILE_SPEC "\
%{!shared:crtend.o%s crtn.o%s} %{shared:crtendS.o%s crtn.o%s}"

#define LINK_OS_SPEC "\
%{mcall-freebsd: %(link_os_freebsd)     ; \
               : %(link_os_default)     }"

#define ASM_OS_SPEC "\
%{mcall-freebsd: %(asm_os_freebsd)     ; \
               : %(asm_os_default)     }"

#define ASM_OS_DEFAULT_SPEC ""

#define LINK_OS_FREEBSD_SPEC "\
  %{!shared: \
    %{!ibcs: \
      %{!static: \
        %{rdynamic:-export-dynamic} \
        %{!dynamic-linker: \
          %{mabi=n32: -dynamic-linker /usr/libexec/ld-elf32.so.1} \
          %{mabi=64: -dynamic-linker /libexec/ld-elf64.so.1} \
          %{mabi=32: -dynamic-linker /usr/libexec/ld-elf.so.1}}} \
      %{static:-static}}} \
%{symbolic:-Bsymbolic} \
%{mabi=n32:-melf32%{EB:b}%{EL:l}tsmipn32_fbsd} \
%{mabi=64:-melf64%{EB:b}%{EL:l}tsmip_fbsd} \
%{mabi=32:-melf32%{EB:b}%{EL:l}tsmip_fbsd}"

#undef LINK_OS_DEFAULT_SPEC
#define LINK_OS_DEFAULT_SPEC "\
  %{!shared: \
      %{!static: \
	      %{rdynamic:-export-dynamic} \
	      %{!dynamic-linker:-dynamic-linker /usr/libexec/ld-elf.so.1}} \
      %{static:-Bstatic}} \
  %{symbolic:-Bsymbolic}"

/* Extra switches sometimes passed to the linker.  */
/* ??? The bestGnum will never be passed to the linker, because the gcc driver
  will interpret it as a -b option.  */
#undef LINK_SPEC
#define LINK_SPEC "\
%{G*} %{EB} %{EL} %{mips1} %{mips2} %{mips3} %{mips4} \
%{mips32} %{mips32r2} %{mips64} %{mips64r2} \
%{bestGnum} %{shared} %{non_shared} \
%{p:%nconsider using `-pg' instead of `-p' with gprof(1) } \
%{v:-V} \
%{assert*} %{R*} %{rpath*} %{defsym*} \
%{shared:-Bshareable %{h*} %{soname*}} \
%(link_os)"

#undef LIB_SPEC
#define LIB_SPEC "\
%{!shared:%{!p:%{!pg:-lc}}%{p:-lc_p}%{pg:-lc_p}}"

#undef STARTFILE_SPEC
#define STARTFILE_SPEC "\
%{!shared:crti.o%s %{!p:%{!pg:crt1.o%s}}%{p|pg:gcrt1.o%s} crtbegin.o%s} \
%{shared:crti%s.o crtbeginS.o%s}"

/* The generic MIPS TARGET_OS_CPP_BUILTINS are incorrect for FreeBSD/JUNOS.
   Specifically, they define too many namespace-invasive macros.  Override
   them here.  Note this is structured for easy comparison to the version
   in mips.h.  */

#undef  TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()				\
  do								\
    {								\
      builtin_define ("__mips__");				\
      builtin_define ("__NO_LEADING_UNDERSCORES__");		\
      builtin_define ("__GP_SUPPORT__");			\
								\
      if (TARGET_64BIT)						\
	builtin_define ("__mips64__");				\
								\
      if (TARGET_FLOAT64)					\
	builtin_define ("__mips_fpr=64");			\
      else							\
	builtin_define ("__mips_fpr=32");			\
								\
      if (TARGET_MIPS16)					\
	builtin_define ("__mips16");				\
								\
      if (ISA_MIPS3)						\
	builtin_define ("__mips=3");				\
      else if (ISA_MIPS4)					\
	builtin_define ("__mips=4");				\
      else if (ISA_MIPS32)					\
	{							\
	  builtin_define ("__mips=32");				\
	  builtin_define ("__mips_isa_rev=1");			\
	}							\
      else if (ISA_MIPS32R2)					\
	{							\
	  builtin_define ("__mips=32");				\
	  builtin_define ("__mips_isa_rev=2");			\
	}							\
      else if (ISA_MIPS64)					\
	{							\
	  builtin_define ("__mips=64");				\
	  builtin_define ("__mips_isa_rev=1");			\
	}							\
								\
      if (TARGET_HARD_FLOAT)					\
	builtin_define ("__mips_hard_float");			\
      else if (TARGET_SOFT_FLOAT)				\
	builtin_define ("__mips_soft_float");			\
								\
      if (TARGET_SINGLE_FLOAT)					\
	builtin_define ("__mips_single_float");			\
								\
      if (TARGET_BIG_ENDIAN)					\
	builtin_define ("__MIPSEB__");				\
      else							\
	builtin_define ("__MIPSEL__");				\
								\
      /* No language dialect defines.  */			\
								\
      if (mips_abi == ABI_EABI)					\
	builtin_define ("__mips_eabi");				\
      else if (mips_abi == ABI_N32)				\
	{							\
	    builtin_define ("_MIPS_SZLONG=32");			\
	    builtin_define ("_MIPS_SZPTR=32");			\
	    builtin_define ("__mips_n32");			\
	}							\
      else if (mips_abi == ABI_64)				\
	{							\
	    builtin_define ("_MIPS_SZLONG=64");			\
	    builtin_define ("_MIPS_SZPTR=64");			\
	    builtin_define ("__mips_n64");			\
	}							\
      else if (mips_abi == ABI_O64)				\
	builtin_define ("__mips_o64");				\
      else							\
	{							\
	    builtin_define ("_MIPS_SZLONG=32");			\
	    builtin_define ("_MIPS_SZPTR=32");			\
	    builtin_define ("__mips_o32");			\
	}							\
								\
      if (TARGET_ABICALLS)					\
	builtin_define ("__ABICALLS__");			\
    }								\
  while (0)

/************************[  Assembler stuff  ]********************************/

#undef  SUBTARGET_ASM_SPEC
#define SUBTARGET_ASM_SPEC "%(asm_os)"

/* -G is incompatible with -KPIC which is the default, so only allow objects
   in the small data section if the user explicitly asks for it.  */

#undef  MIPS_DEFAULT_GVALUE
#define MIPS_DEFAULT_GVALUE 0

/* Standard AT&T UNIX 'as' local label spelling.  */
#undef  LOCAL_LABEL_PREFIX
#define LOCAL_LABEL_PREFIX (((mips_abi == ABI_N32) || (mips_abi == ABI_64)) ? "." : "$")

