/*
 * $Id: sched.h 658455 2014-07-12 02:36:59Z ib-builder $
 *
 * sched.h wrapper for C++
 *
 * Stu Grossman, June 2007
 *
 * Copyright (c) 2007, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * This wrapper fixes a problem where pthread.h gets pfe/include/sched.h
 * instead of /usr/include/sched.h (which is a completely different file).
 */

#ifndef __LIBSTDCXX_NATIVE_SCHED_H__
#define __LIBSTDCXX_NATIVE_SCHED_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __linux__
#define USE_SYSTEM_SCHED_H
#include_next <sched.h>
#else
#include </usr/include/sched.h>
#endif

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_NATIVE_SCHED_H__ */
