/*
 * $Id: string.h 658455 2014-07-12 02:36:59Z ib-builder $
 *
 * string.h wrapper for C++
 *
 * Stu Grossman, June 2007
 *
 * Copyright (c) 2007, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * This wrapper provides a way for libstdc++ (and possibly other 3rd party
 * code) to avoid the problems in pfe/include/string.h.  pfe/include/string.h
 * lacks many of the defs which are needed by the C++ <string> header.
 */

#ifndef __LIBSTDCXX_NATIVE_STRING_H__
#define __LIBSTDCXX_NATIVE_STRING_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __linux__
#define USE_SYSTEM_STRING_H
#include_next <string.h>
#else
#include </usr/include/string.h>
#endif

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_NATIVE_STRING_H__ */
